<template>
    <div class="app-container">        
        <el-row :gutter="20">
            <el-col :lg="16" :md="16" :sm="24">
                <div class="paper grid text-align-center">
                    <h4>Track Document</h4>
                    <el-input 
                        v-model="trackingNumber"
                        placeholder="Tracking number" 
                        class="input-with-select"
                        clearable
                        @clear="handleTrackingClear()">
                        <el-button @click="trackDocument" slot="append" icon="el-icon-search"></el-button>
                    </el-input>
                    <div v-if="document != null" class="text-align-left display-block margin-medium-top" :loading="trackingLoading">

                        <el-row :gutter="20">
                            <el-col :lg="3" :md="3" :sm="24">
                                <qrcode ref="qr" :value="document.tracking_number" :options="{ width: 100 }" tag="img"></qrcode>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <h4>{{ document.title }}</h4>
                                <span>{{ document.tracking_number }}</span>
                            </el-col>
                        </el-row>
                        <el-row :gutter="20">
                            <el-col :lg="24" :md="24" :sm="24">
                                <el-timeline class="no-padding margin-medium-top">
                                    <el-timeline-item
                                        v-for="(status, index) in document.statuses" 
                                        :key="index"
                                        :timestamp="dateFormat(status.status.created)"
                                        placement="top">
                                            <h4 style="margin:0;">{{ status.status.name }} <i class="ion-ios-notifications" style="color:#E65D6E;" v-if="status.notified"></i></h4>
                                            <small style="font-sze:12px;">Updated by: {{ status.author.fullname.capitalize() }}</small>
                                            <p>{{ status.note }}</p>
                                    </el-timeline-item>
                                </el-timeline>
                            </el-col>
                        </el-row>                         
                    </div>
                </div>
            </el-col>
            <el-col :lg="8" :md="8" :sm="24">
                <div class="paper grid">
                    <h4>Last Document Uploaded</h4>
                    <el-timeline class="no-padding" :loading="mediaLoading">
                        <el-timeline-item
                            v-for="(media, index) in medias" 
                            :key="index"
                            :timestamp="dateFormat(media.created)"
                            placement="top">
                                <h4 style="margin:0;">{{ media.original_filename }}</h4>
                                <small style="font-sze:12px;">{{ media.document.title }} - {{ bytesToSize(media.size) }}</small>
                        </el-timeline-item>
                    </el-timeline> 
                </div>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, bytesToSize, convertAmpersand } from '../../utils/index';
export default {
    name: 'Dashboard',
    data() {
        return {
            trackingLoading: false,
            mediaLoading: false,
            trackingNumber: null
        }
    },
    computed: {
        ...mapGetters('auth', ['token', 'user']),
        ...mapGetters('media', ['medias']),
        ...mapGetters('document', ['document'])
    },
    created() {
        const self = this;

        self.getAttachments();
    },
    methods: {
        dateFormat,
        bytesToSize,
        getAttachments(){
            const self = this;

            self.mediaLoading = true;

            self.$store.dispatch('media/getMedias', {
                page: 1,
                perpage: 10
            }).then(()=>{
                self.mediaLoading = false;
            });
        },
        trackDocument(){
            const self = this;

            self.trackingLoading = true;

            self.$store.dispatch('document/trackDocument', {
                tracking_number: self.trackingNumber,
                only: 'id,created,updated,tracking_number,document_number,title,remarks,statuses,author.fullname'
            }).then(()=>{
                self.trackingLoading = false;
            });
        },
        handleTrackingClear(){
            const self = this;
            self.$store.dispatch('document/resetDocument');
        }
    }
}
</script>